**********************************************************
*
*       GKS emulacija, Tomaz Kolsek, LECAD
*
*       Fakulteta za strojnistvo
*
*       popravki: 
*       FEB 11 1994 :inicializacija fonta in velikosti crk
*       FEB 16 1994:    gpl(x,y,n) --> gpl(n,x,y)
*                       gdp(n,px,py,primid,ldr,datrec)
*                       primid = -1 ... krogi
*                       primid = -2 ... loki
*                       gstxci(n)
*         JAN 3 1995:  povecanje stevila tock v poligonu na 1000
*                      dodana rutina GCLS - clearscreen
*
**********************************************************

	include 'fgraph.fi'
	include 'flib.fi'

**********************************************************

      subroutine gopks()

	include 'fgraph.fd'

	integer*2               dummy, maxx, maxy
	record /videoconfig/ myscreen
		
	common                  maxx, maxy
	
c	dummy = setvideomode($MAXCOLORMODE)
	dummy = setvideomode($MAXRESMODE)
c	dummy = setvideomode($ZRES256COLOR)
	call getvideoconfig( myscreen )

	if( dummy .eq. 0 ) STOP 'Error: can not set graphic mode'

	call getvideoconfig( myscreen )
	maxx = myscreen.numxpixels - 1
	maxy = myscreen.numypixels - 1


	dummy =  registerfonts('*.fon')

c       --- inicializacija fonta in velikosti crk

	dummy = setfont( "t'modern'" // 'h15w12b' )


	END


c       *****************************************

	subroutine gpl(n,x,y)

	include 'fgraph.fd'

	record /wxycoord/ wxy
	real            x(10000),y(10000)
	integer         n, plci
	common /plc/    plci


	call gsplci(plci)

	call moveto_w( dble(x(1)),dble(y(1)), wxy )

	do 10 i=2,n

10      dummy=lineto_w( x(i), y(i) )

	return
	end

c       *****************************************

	subroutine gdp(n,px,py,primid,ldr,datrec)

c       --- glej GKS standard, stran 216
c       --- ta rutina rise kroge in loke (primid = -1,-2) !!

	include 'fgraph.fd'

	integer                 n, plci
	real            px(3),py(3)     
	real            x(100), y(100)
	integer         primid, ldr
*       character*80    datrec(2)
	character*80    datrec
	real            sx, sy, r
	real            dfi, fi_begin, fi_end, dfi_step, dfi_default
	real            fi_diff
	real            kot

	common /plc/    plci

	if (n .lt. 2) stop '*** Error in GDP : n < 2 ***'
	if ( (primid .gt. -1) .or. (primid .lt. -2) )
     *  stop '*** Error in GDP : primitive id not consistent ***'

      idfi_default = 5
	dfi_default = 5.

	if (ldr .eq. 2) then
		if ( (datrec .eq. ' ') .or. (len(datrec) .eq. 0) ) 
     *          datrec = '5'
		read(datrec,'(i10)', err=5) idfi_default
		dfi_default = real(idfi_default)
		endif


c       --- sredisce kroga je sx,sy, radij je r
5       sx = px(1)
	sy = py(1)
	r = sqrt(abs((sx-px(2)))**2 + abs((sy-py(2)))**2 )

	fi_begin = kot(px(2)-px(1),py(2)-py(1))

	if (primid .eq. -1) fi_end = fi_begin + 360.
	if (primid .eq. -2) fi_end = kot(px(3)-px(1),py(3)-py(1))
	if (fi_end .le. fi_begin) fi_end = fi_end + 360.

	fi_diff = fi_end - fi_begin

	dfi_step = fi_diff / (int(fi_diff/dfi_default+0.5) )


c      write(*,*)'2.begin,end,diff,step=',fi_begin,fi_end,fi_diff,
c     *         dfi_step

      fi_begin = fi_begin*3.14159/180.
	fi_end   = fi_end*3.14159/180.
	dfi_step = dfi_step*3.14159/180.

	
	i = 0

	
	do 10 dfi = fi_begin, fi_end+dfi_step/2., dfi_step
			i = i+1
			x(i) = sx + r*cos(dfi)
10                      y(i) = sy + r*sin(dfi) 

c       write(*,*)'x(1),i,x(i-1),x(i) = ',x(1),i,x(i-1),x(i)
  
	call gpl(i,x,y)


	end


c       *****************************************

	subroutine gsplci(n)


	include 'fgraph.fd'

	
	integer*2       dummy
	integer         plci, n  
	integer     barvna_tabela(16)/1,2,3,4,5,6,7,8,9,10,11,12,
     *                         13,14,15,16/
	common /plc/    plci

	   dummy=setcolor(barvna_tabela(n))
	   plci = n

	end



c       *****************************************

	subroutine gstxci(n)


	include 'fgraph.fd'

	
	integer*2       dummy
	integer         txci, n  
	integer     barvna_tabela(16)/1,2,3,4,5,6,7,8,9,10,11,12,
     *                         13,14,15,16/
	common /txc/    txci

	   dummy=setcolor(barvna_tabela(n))
	   txci = n

	end



c       *****************************************

      subroutine gclks()


	include 'fgraph.fd'
	include 'flib.fd'

	integer*2 dummy

	read (*,*)
c	dummy = setvideomode( $TEXTC80 )
	dummy = setvideomode( $DEFAULTMODE )
	end

c       *****************************************


	subroutine gswn(trn,x1,y1,x2,y2)

	include 'fgraph.fd'

	real x1,y1,x2,y2
	integer trn
	integer*2 dummy
	logical*2 finvert/'.TRUE.'/

	dummy = trn
	dummy = setwindow(finvert,dble(x1),dble(y1),dble(x2),dble(y2))

	end

c*************************************************

	subroutine gswkvp(trn,x1,y1,x2,y2)


	real x1,y1,x2,y2
	integer*2 maxx,maxy
	integer trn
	common maxx,maxy

	dummy = trn
	call setviewport(x1,maxy-y1,x2,maxy-y2)
	
	call okvir()

	end

c       *********************************************

	subroutine gtx(x,y,tekst)

	include 'fgraph.fd'

	real            x,y
	character*(*)   tekst
	record /wxycoord/ wxy
	integer         txci

	common /txc/    txci

	call gstxci(txci)
	call moveto_w(dble(x),dble(y),wxy)
	call outgtext(tekst)

	return
	end

c       ******************************************

      subroutine okvir()

      real okvirx(5),okviry(5)
	integer trn

      okvirx(1) = 0.
	okvirx(2) = 100.
	okvirx(3) = 100.
	okvirx(4) = 0.
	okvirx(5) = 0.
	okviry(1) = 0.
	okviry(2) = 0.
	okviry(3) = 100.
	okviry(4) = 100.
	okviry(5) = 0.

	call gswn(trn,0.,0.,100.,100.)
	call gpl(5,okvirx,okviry)

      end

c       ******************************************


	subroutine gschh(height)

	include 'fgraph.fd'
	integer height, width
	character*10 control


	if (height .gt. 99 ) 
     *      stop '** Error in GSCHH: text height > 99 !'
	width = int( 0.6 * height )

	control(1:1) = 'h'
	write(control(2:3),'(i2.2)') height
	control(4:4) = 'w'
	write(control(5:6),'(i2.2)') width
	control(7:7) = 'b'

c        write(*,*) 'control=',control

	dummy = setfont( "t'modern'" // control )

	return
	end

c    ******************************************

	subroutine gcls()

	include 'fgraph.fd'

	call clearscreen($GCLEARSCREEN)

	return
	end


	real function KOT(DX,DY)

C       --- Podprogram za dolocevanje kota glede na podane katete

	RERR=1.0E-6

c       ... Kontroliranje velikosti DX zaradi singularnosti Tangensa
	if(abs(dx).lt.rerr)then
	  if    (dy.gt.0.0)then  
	   kot=90.0
	   return
	  elseif(dy.lt.0.0)then
	   kot=270.0
	   return
	  elseif(abs(dy).lt.rerr)then
	   kot=0.0
	   return
	  endif
	endif

c       ... izracun kota
	kot = 180./3.14159 * atan(dy/dx)

c       ... preverjanje kvadranta in izracun pravega kota v limitah 0 do 360
c           stopinj

c       !drugi kvadrant
	if    (dx.lt.0.0.and.dy.ge.0.0)then  
	kot=180.0+kot                          
c       !tretji kvadrant
	elseif(dx.lt.0.0.and.dy.lt.0.0)then  
	kot=180.0+kot
c       !cetrti kvadrant
	elseif(dx.gt.0.0.and.dy.lt.0.0)then  
	kot=360.0+kot
	endif

	return
	end

c	******************************************************

